# Helimig.x <in.H >out.H
#
# 3D implicit finite difference migration
#	in the (omega,x,y,z)-domain
#
# in.H should be arranged in frequency slices
#
#%

integer n1,n2,n3,nz

from history:	integer n1, n2, n3
from par:	integer nz=n3*2

allocate:	complex input(n1,n2)
allocate:	real output(n1,n2,nz),vel(nz)

subroutine main(input,output,vel, n1,n2,n3,nz)
 
integer n1,n2,n3,nz,i3,nv,i
complex input(n1,n2,n3)
real output(n1,n2,nz),vel(nz)
real d1,d2,d3, o1,o2,o3, w,dz, v,pi,dv

from history:	real d1,d2,d3, o1,o2,o3
from par:	real dz=d1, v=-1.
to history:	integer n1, n2, n3:nz, esize:4
to history:	real d1, d2, d3:dz
call hclose()

pi=4*atan(1.); d3=-d3*2*pi; o3=-o3*2*pi
if (d1.ne.d2)	call seperr(' d1.ne.d2 ')
if (n3.le.2)	call seperr(' n3.le.2 ')

if (v.le.0) {	# Read velocity from file
	call sreed('vel',vel,nz*4)
} else {	# Constant velocity
	do i=1, nz { vel(i)=v }
}

call zero(n1*n2*nz,output)

do i3=1, n3 { w=o3+(i3-1)*d3

write(0,*) i3,w,n3
	# Read frequency slice
	call sreed('in', input, n1*n2*8)

	# Helical migration
	call helimig(input, output, nz,dz, w, n1,d1,n2,d2, vel)
}

call srite('out', output,n1*n2*nz*4)
return;	end


