program Grad2fil
  !  <binned.H Locutfill2.x niter=200 > full.H
  !       fill empty bins in 2-D by minimizing the Locutlacian
  !               No side boundary conditions.  Prescribe your own in the bins.
  !
  !   binned.H has empty bins with zero values.
  use grad2fill
  use sep

  implicit none
  integer                            :: n12, niter, n1, n2, b1, b2
  real                               :: r1, r2, d1, d2, o1, o2
  real, dimension (2)                :: d, o
  real, dimension (:,:), allocatable :: map

  call sep_init ()
  call from_history (n1, n2) ; n12 = n1*n2
  call from_par ("niter", niter, 50)

  call from_history ("o1", o1) ; call from_history ("d1", d1)
  call from_history ("o2", o2) ; call from_history ("d2", d2)

  call from_par ("nrect1", b1, 1) ; call from_par ("rect1", r1, b1*d1)
  call from_par ("nrect2", b2, 1) ; call from_par ("rect2", r2, b2*d2)

  b1 = .5 + r1/d1
  b2 = .5 + r2/d2

  call to_history ("nrect1", b1)
  call to_history ("nrect2", b2)
  call sep_close ()

  allocate (map (n1,n2))
  call sep_read (map)
  call grad2fill2 (niter, n1,n2, map, (map /= 0.)) 
  call sep_write (map)
  deallocate (map)
  call exit (0)
end program Grad2fil


