program Input
  ! Impulse response of cyclic 2-D polynomial division.
  use sep

  integer                            :: n1,n2 !, a1,a2, mid
  real	                             :: t, t0, dt = .45
  real, dimension (:,:), allocatable :: p !, aa

  call sep_init ()
  call from_par ("n1",n1,64)
  call from_par ("n2",n2,n1)
  call to_history ("n3",1)
  call to_history ("esize",4)

!  if (exist_file ("filt")) then
!     call from_aux("filt", a1, a2)
!     allocate (aa (a1,a2))
!     call sep_read (aa, "filt")
!  else
!     a1 = 1; a2 = 1
!     allocate (aa (1,1))
!     aa = 1.
!  end if

  allocate (p (n1, n2)) ; p = 0.

  t0 =    - dt*(n1/3)
  do i1= 1, n1 
     t  = t0 + dt*(i1-1)
     p(i1,  n2/4) = (2*t**2-1) * exp( -t**2)
  end do

  t0 =    - dt*(n1*.7)
  do i1= 1, n1 
     t  = t0 + dt*(i1-1)
     p(i1,  n2/5) =  exp( -t**2)/ 2.
  end do

  p(n1/3,  3*n2/4) = + 1.
  p(n1-1 , 3*n2/4) = - 1.

!  mid = 1+a1/2
!  if (aa(mid,1) == 0.)  call erexit('illegal for aa(1+a1/2,1)==0.')
!  aa = aa/aa( mid, 1)

!  p(n1/2+1:n1/2+a1, n2/2+1:n2/2+a2) = &
!  p(n1/2+1:n1/2+a1, n2/2+1:n2/2+a2) + aa

  call sep_write(p)

  deallocate (p)
  call exit (0)
end program Input

